src/MyVod/Areas/Admin/Controllers/DashboardController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;

namespace MyVod.Areas.Admin.Controllers;

[Authorize]
[Area("admin")]
public class DashboardController : Controller
{
    // GET
    public IActionResult Index()
    {
        return View();
    }
}

src/MyVod/Areas/Admin/Controllers/GenreController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using MyVod.Infrastructure.Models;
using MyVod.Services;

namespace MyVod.Areas.Admin.Controllers;

[Authorize]
[Area("admin")]
public class GenreController : Controller
{
    private readonly IGenreService _genreService;

    public GenreController(IGenreService genreService)
    {
        _genreService = genreService;
    }

    [HttpGet]
    public async Task<IActionResult> Index()
    {
        var genres = _genreService.Get();

        return View("Index", genres.AsEnumerable());
    }

    [HttpGet]
    [ActionName("create")]
    public IActionResult CreateView()
    {
        return View("Create");
    }

    [HttpPost]
    [ActionName("create")]
    public async Task<IActionResult> Create(Genre genre)
    {
        if (ModelState.IsValid)
        {
            await _genreService.Create(genre);
            
            return RedirectToAction(nameof(Index));
        }

        return BadRequest();
    }

    [HttpGet("{area}/{controller}/{action}/{id:guid}")]
    [ActionName("edit")]
    public async Task<IActionResult> EditView(Guid id)
    {
        var genre = await _genreService.Get(id);

        if (genre is null)
            return NotFound();

        return View("Edit", genre);
    }

    [HttpPost("{area}/{controller}/{action}/{id:guid}")]
    [ActionName("edit")]
    public async Task<IActionResult> Edit(Guid id, Genre genre)
    {
        if (id != genre.Id)
            return BadRequest();
            
        if (ModelState.IsValid)
        {
            await _genreService.Update(genre);
            
            return RedirectToAction(nameof(Index));
        }

        return BadRequest();
    }

    [HttpGet("{area}/{controller}/{action}/{id:guid}/delete")]
    [ActionName("delete")]
    public async Task<IActionResult> Delete(Guid id)
    {
        if (ModelState.IsValid)
        {
            await _genreService.Delete(id);
            
            return RedirectToAction(nameof(Index));
        }

        return BadRequest();
    }
}

src/MyVod/Areas/Admin/Controllers/MovieController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using MyVod.Areas.Admin.ViewModels;
using MyVod.Infrastructure.Models;
using MyVod.Services;

namespace MyVod.Areas.Admin.Controllers;

[Authorize]
[Area("admin")]
public class MovieController : Controller
{
    private readonly IMovieService _movieService;
    private readonly IPersonService _personService;
    private readonly IGenreService _genreService;

    public MovieController(IMovieService movieService, IPersonService personService, IGenreService genreService)
    {
        _movieService = movieService;
        _personService = personService;
        _genreService = genreService;
    }

    public IActionResult Index()
    {
        var movies = _movieService.Get();
        
        return View("Index", movies.AsEnumerable());
    }
    
    [HttpGet]
    [ActionName("create")]
    public IActionResult CreateView()
    {
        var persons = _personService.Get();
        var genres = _genreService.Get();

        var moviePageModel = new MoviePageModel
        {
            Persons = persons.AsEnumerable().Select(x => new SelectListItem($"{x.FirstName} {x.LastName}", x.Id.ToString())).ToList(),
            Genres = genres.AsEnumerable().Select(x => new SelectListItem(x.Name, x.Id.ToString())).ToList(),
        };
        
        return View("Create", moviePageModel);
    }

    [HttpPost]
    [ActionName("create")]
    public async Task<IActionResult> Create(MoviePageModel movie)
    {
        movie.Current.DirectorId = movie.Director;
        movie.Current.GenreId = movie.Genre;
            
        await _movieService.Create(movie.Current);
        
        return RedirectToAction(nameof(Index));
    }
    
    [HttpGet("{area}/{controller}/{action}/{id:guid}/delete")]
    [ActionName("delete")]
    public async Task<IActionResult> Delete(Guid id)
    {
        if (ModelState.IsValid)
        {
            await _movieService.Delete(id);
            
            return RedirectToAction(nameof(Index));
        }

        return BadRequest();
    }
    
    [HttpGet("{area}/{controller}/{action}/{id:guid}")]
    [ActionName("edit")]
    public async Task<IActionResult> EditView(Guid id)
    {
        var movie = await _movieService.Get(id);

        if (movie is null)
            return NotFound();
        
        var persons = _personService.Get();
        var genres = _genreService.Get();

        var moviePageModel = new MoviePageModel
        {
            Persons = persons.AsEnumerable().Select(x => new SelectListItem($"{x.FirstName} {x.LastName}", x.Id.ToString())).ToList(),
            Genres = genres.AsEnumerable().Select(x => new SelectListItem(x.Name, x.Id.ToString())).ToList(),
            Current = movie
        };

        return View("Edit", moviePageModel);
    }

    [HttpPost("{area}/{controller}/{action}/{id:guid}")]
    [ActionName("edit")]
    public async Task<IActionResult> Edit(Guid id, MoviePageModel movie)
    {
        if (id != movie.Current.Id)
            return BadRequest();
        
        movie.Current.DirectorId = movie.Director;
        movie.Current.GenreId = movie.Genre;
        
        await _movieService.Update(movie.Current);
        
        return RedirectToAction(nameof(Index));
    }
}

src/MyVod/Areas/Admin/Controllers/PersonController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using MyVod.Infrastructure.Models;
using MyVod.Services;

namespace MyVod.Areas.Admin.Controllers;

[Authorize]
[Area("admin")]
public class PersonController : Controller
{
    private readonly IPersonService _personService;

    public PersonController(IPersonService personService)
    {
        _personService = personService;
    }

    [HttpGet]
    public async Task<IActionResult> Index()
    {
        var persons = _personService.Get();

        return View("Index", persons.AsEnumerable());
    }

    [HttpGet]
    [ActionName("create")]
    public IActionResult CreateView()
    {
        return View("Create");
    }

    [HttpPost]
    [ActionName("create")]
    public async Task<IActionResult> Create(Person genre)
    {
        if (ModelState.IsValid)
        {
            await _personService.Create(genre);
            
            return RedirectToAction(nameof(Index));
        }

        return BadRequest();
    }

    [HttpGet("{area}/{controller}/{action}/{id:guid}")]
    [ActionName("edit")]
    public async Task<IActionResult> EditView(Guid id)
    {
        var genre = await _personService.Get(id);

        if (genre is null)
            return NotFound();

        return View("Edit", genre);
    }

    [HttpPost("{area}/{controller}/{action}/{id:guid}")]
    [ActionName("edit")]
    public async Task<IActionResult> Edit(Guid id, Person genre)
    {
        if (id != genre.Id)
            return BadRequest();
            
        if (ModelState.IsValid)
        {
            await _personService.Update(genre);
            
            return RedirectToAction(nameof(Index));
        }

        return BadRequest();
    }

    [HttpGet("{area}/{controller}/{action}/{id:guid}/delete")]
    [ActionName("delete")]
    public async Task<IActionResult> Delete(Guid id)
    {
        if (ModelState.IsValid)
        {
            await _personService.Delete(id);
            
            return RedirectToAction(nameof(Index));
        }

        return BadRequest();
    }
}

src/MyVod/Areas/Admin/Controllers/TransactionsController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using MyVod.Areas.Admin.ViewModels;
using MyVod.Infrastructure.Models;
using MyVod.Services;

namespace MyVod.Areas.Admin.Controllers;

[Authorize]
[Area("admin")]
public class TransactionsController : Controller
{
    private readonly IOrderService _orderService;

    public TransactionsController(IOrderService orderService)
    {
        _orderService = orderService;
    }
    
    [HttpGet]
    public async Task<IActionResult> Index()
    {
        var orders = await _orderService.Get();

        var model = new TransactionsPageModel
        {
            OnGoing = orders.Where(x => x.Status == OrderStatus.Pending).ToList(),
            Completed = orders.Where(x => x.Status != OrderStatus.Pending).ToList()
        };
        
        return View("Index", model);
    }
}

src/MyVod/Areas/Admin/Views/Dashboard/Index.cshtml
@{
    ViewBag.Title = "Dashboard";
    Layout = "_Layout";
}

<h2 class="page-header">Admin Dashboard</h2>

<div class="dashboard-container">
    <div class="row row-cols-1 row-cols-md-4 g-4">
        <div class="col">
            <div class="card h-100" style="width: 18rem;">
                <img class="card-img-top" src="../img/theaters.svg" alt="Card image cap">
              <div class="card-body admin-card-container">
                <div>
                    <h5 class="card-title">Genres</h5>
                    <p class="card-text">CRUD for Genres</p>
                </div>
                    <a asp-area="admin" asp-controller="Genre" asp-action="Index" class="btn btn-primary">Go</a>
                </div>
            </div>
        </div>
        <div class="col">
            <div class="card h-100" style="width: 18rem;">
                <img class="card-img-top"  src="../img/manage_accounts.svg" alt="Card image cap">
              <div class="card-body admin-card-container">
                <div>
                    <h5 class="card-title">Persons</h5>
                    <p class="card-text">CRUD for Persons</p>
                </div>
                    <a asp-area="admin" asp-controller="Person" asp-action="Index" class="btn btn-primary">Go</a>
                </div>
            </div>
        </div>
        <div class="col">
            <div class="card h-100" style="width: 18rem;">
                <img class="card-img-top" src="../img/movie_filter.svg" alt="Card image cap">
              <div class="card-body admin-card-container">
                <div>
                    <h5 class="card-title">Movies</h5>
                    <p class="card-text">Movies for Persons</p>
                </div>
                    <a asp-area="admin" asp-controller="Movie" asp-action="Index" class="btn btn-primary">Go</a>
                </div>
            </div>
        </div>
        <div class="col">
            <div class="card h-100" style="width: 18rem;">
              <img class="card-img-top" src="../img/shopping_cart.svg" alt="Card image cap">
              <div class="card-body admin-card-container">
                <div>
                    <h5 class="card-title">Transactions</h5>
                    <p class="card-text">Transactions</p>
                </div>
                <a asp-area="admin" asp-controller="Transactions" asp-action="Index" class="btn btn-primary">Go</a>
              </div>
            </div>
        </div>
    </div>
</div>